[![Build Status](https://travis-ci.org/android-hacker/VirtualXposed.svg?branch=exposed)](https://travis-ci.org/android-hacker/VirtualXposed)

[中文文档](CHINESE.md "中文")

Introduction
------------
**VirtualXposed** is a simple APP based on [VirtualApp](https://github.com/asLody/VirtualApp) and [epic](https://github.com/tiann/epic) that lets you use the Xposed Module without needing to root, unlock the bootloader, or flash a system image. (Support Android 5.0~8.1)

Warning
-----------

No use for Commercial Purposes!!!  Please refer to VirtualApp's [declaration](https://github.com/asLody/VirtualApp).

Usage
-------

### Preparation

Download the latest apk from the [release page](https://github.com/android-hacker/VirtualXposed/releases), and install it on your Android device.

### Install APP and Xposed module

Open VirtualXposed, Click the ➕ in home page, add the APP and Xposed module to VirtualXposed's virtual environment.

Notice: **All operations（installing Xposed module, APP）must be done in VirtualXposed**, otherwise the Xposed module won't take effect. For example, if you install the YouTube app on your system (Your phone's original system, not in VirtualXposed), and then install YouTube AdAway (A YouTube Xposed module) in VirtualXposed; or you install YouTube in VirtualXposed, and install YouTube AdAway on original system; or both of them are installed on original system, **yhese three cases won't take effect!**

![How to install](https://raw.githubusercontent.com/tiann/arts/master/vxp_install.gif)

There are three ways to install an app or Xposed module to VirtualXposed:

1. Clone the original system's installed apps. Click Button at bottom of home page, then click Add App, the first page are installed apps.
2. Install via an APK file. (Click Button at bottom of home page, then click Add App, the second page are apks found in your sdcard)
3. Install via the external file chooser. (Click Button at bottom of home page home page, then click App App, use the float button to choose apk file to install)

For Xposed module, You can install it from XposedInstaller, too.

### Activate the Xposed module

Open XposedInstaller in VirtualXposed, go to the module fragment, check the module you want to use:

![How to activate module](https://raw.githubusercontent.com/tiann/arts/master/vxp_active.gif)

### Reboot

Reboot the VirtualXposed, **No need to reboot your phone**; Just click Settings in home page of VirtualXposed, click `Reboot` button, and VirtualXposed will reboot like a shot. 

![How to reboot](https://raw.githubusercontent.com/tiann/arts/master/vxp_reboot.gif)

Supported Modules
--------------------

- [微X模块][wx]: 微信模块，功能全面；但与VXP兼容性一般。
- [微信巫师][wxws]: 微信模块，项目开源，代码优秀。
- [MDWechat][mdwechat]: 微信美化模块，可以把微信整成MD风格。
- [应用变量][yybl]: 可以用来进行机型修改，比如王者荣耀高帧率；QQ空间修改小尾巴等。
- [音量增强器][ylzqq]: 网易云音乐模块，非常好用，低调。
- [微信学英语][wxxyy]: 自动把微信消息翻译为英语，非常实用。
- [冲顶助手][cdzs]: 答题辅助模块。
- [情迁抢包][qqqb]: 抢红包模块，兼容性一般。
- [微信跳一跳助手][ttzs]: 微信跳一跳游戏辅助模块。
- [步数修改器][bsxg]: 运动步数修改模块。
- [模拟位置][mnwz]: 虚拟定位模块，稳定好用。
- [指纹支付][zwzf]: 对不支持指纹支付但系统本身有指纹的手机开启指纹支付的模块。
- [QQ精简模块 2.0][qqjj]: QQ模块，不仅可以精简QQ，还能防撤回，防闪照。VXP不支持QX，推荐用这个。
- [微信增强插件][wxzqcj]: 微信模块，VXP内最稳定的微信模块；如无特殊需求建议用这个。
- [QQ斗图神器][qqdtsq]: 各种表情，斗图神器。
- [微信斗图神器][wxdtsq]: 斗图神器，微信用的。
- [大圣净化][dsjh]: 去广告神器，推荐使用。

Far more than above.

Others
-------

### GameGuardian

VirtualXposed also supports GameGuardian, **use version 0.9.1 for best compatibility**.(You can download it in release page).

[Video Tutorial](https://gameguardian.net/forum/gallery/image/437-no-root-via-virtualxposed-without-error-105-gameguardian/)

### VirusTotal

VirusTotal may say VirtualXposed has malware, it is stupid, you can refer to my [explanation](https://github.com/android-hacker/VirtualXposed/issues/10).

And VirtualXposed is obviously open source, so you can refer to the source code. I am sure it is safe.

If you still do not believe me, you can install version [0.8.7](https://github.com/android-hacker/VirtualXposed/releases/tag/0.8.7); VirusTotal says this version is safe.


Known Issues
-------------

1. Cannot modify system, so the Module used to modify system can never take effect.
2. Do not support Resource hooks now.
3. Some modules may not be compatible with VirtualXposed now.

Support
-----------

Welcome to contributing for VirtualXposed!!

For Developer
--------------

- [Fire a bug](https://github.com/android-hacker/exposed/issues)
- [Wiki](https://github.com/android-hacker/VirtualXposed/wiki)

Credit
-------

1. [VirtualApp](https://github.com/asLody/VirtualApp)
2. [Xposed](https://github.com/rovo89/Xposed)

[wx]: https://pan.baidu.com/s/1hrOzCnq#list/path=%2Freleases%2Fapk&parentPath=%2Freleases
[wxws]: https://github.com/Gh0u1L5/WechatMagician/releases
[yybl]: https://www.coolapk.com/apk/com.sollyu.xposed.hook.model
[ylzqq]: https://github.com/bin456789/Unblock163MusicClient-Xposed/releases
[wxxyy]: https://www.coolapk.com/apk/com.hiwechart.translate
[cdzs]: https://www.coolapk.com/apk/com.gy.xposed.cddh
[qqqb]: http://repo.xposed.info/module/cn.qssq666.redpacket
[ttzs]: http://repo.xposed.info/module/com.emily.mmjumphelper
[mnwz]: https://www.coolapk.com/apk/com.rong.xposed.fakelocation
[zwzf]: https://github.com/android-hacker/Xposed-Fingerprint-pay/releases
[bsxg]: https://www.coolapk.com/apk/com.specher.sm
[mdwechat]: https://github.com/Blankeer/MDWechat
[wxzqcj]:https://github.com/firesunCN/WechatEnhancement
[qqjj]: https://www.coolapk.com/apk/me.zpp0196.qqsimple
[qqdtsq]: https://www.coolapk.com/apk/x.hook.qqemoji
[wxdtsq]: https://www.coolapk.com/apk/x.hook.emojihook
[dsjh]: https://wiki.ad-gone.com/archives/32/
